#include<bits/stdc++.h>
#include<string>
using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, q,t, u , v;
    string c;
    cin>>n;
    vector<string> a(100002);
    string s="";
    cin>>q;
    for(int i=0; i<=100001; i++){
        a[i] = s;
    }
    for(int i=0; i<q; i++){
        cin>>t;
        if(t==1){
            cin>>u>>v>>c;
            a[v] = a[u] +=c;
        }
        if(t==2){
            cin>>u>>v;
            s = a[v];
            s = s.substr(u-1, v-u);
            int i=0, j=s.length()-1;
            while(i<j){
            if(s[i]!=s[j]) {cout<<0<<endl;break;}
            i++;
            j--;}
            if(j<=i)cout<<1<<endl;

        }
    }

}